//--- Class declaration
#include "ortool_template_tool.h"

//.#include <iostream.h>
//using namespace std;

//--- Registration defines
#define ORTOOLTEMPLATE__CLASS	ORTOOLTEMPLATE__CLASSNAME
#define ORTOOLTEMPLATE__LABEL	"Testing Code UI"
#define ORTOOLTEMPLATE__DESC	"Support - Test Plugin"

//--- FiLMBOX implementation and registration
FBToolImplementation(	ORTOOLTEMPLATE__CLASS	);
FBRegisterTool		(	ORTOOLTEMPLATE__CLASS,
						ORTOOLTEMPLATE__LABEL,
						ORTOOLTEMPLATE__DESC,
						FB_DEFAULT_SDK_ICON		);	// Icon filename (default=Open Reality icon)

#include <math.h>

static FBProperty* scalePpty = NULL;
/*****************************************************************************/
/*                                                                           */
/*                                METHODS                                    */
/*                                                                           */
/*****************************************************************************/

bool ORTool_Template::FBCreate()
///////////////////////////////////////////////////////////////////////////////
//	ORSDK Constructor
///////////////////////////////////////////////////////////////////////////////
{
	// Set the size of the window
	//
	StartSize[0] = 1200;
	StartSize[1] = 1200;

	// Configure Scene
	//
	ConfigureScene();

	// Create the UI
	//
	UICreate();

	// Configure the UI
	//
	UIConfigure();

	// Reset the UI
	//
	UIReset();

	// Add Show and Idle callbacks
	//
	OnShow.Add( this, (FBCallback) &ORTool_Template::EventToolShow );
	OnIdle.Add( this, (FBCallback) &ORTool_Template::EventToolIdle );

	return true;
}

void ORTool_Template::FBDestroy()
///////////////////////////////////////////////////////////////////////////////
//	ORSDK Destructor
///////////////////////////////////////////////////////////////////////////////
{
	// Remove tool callbacks
	OnShow.Remove	( this, (FBCallback) &ORTool_Template::EventToolShow	);
	OnIdle.Remove	( this, (FBCallback) &ORTool_Template::EventToolIdle	);
	mExecute_GapKeys_Button.OnClick.Remove( this, (FBCallback) &ORTool_Template::EventExecute_GapKeys_ButtonClick );		
		
}

void ORTool_Template::ConfigureScene()
///////////////////////////////////////////////////////////////////////////////
//	Configure the Scene
///////////////////////////////////////////////////////////////////////////////
{
	// Load files or configure scenes
	// 
//	char* filePath = "";
//	mApplication.FileOpen( filePath );
}

void ORTool_Template::UICreate()
///////////////////////////////////////////////////////////////////////////////
//	Creates the UI
///////////////////////////////////////////////////////////////////////////////
{
	int lSpace		= 4;
	int lButtonW	= 100;
	int lButtonH	= 18;
//	int lEditW		= 375;
//	int lEditH		= 18;
//	int lBrowseW	= 20;
//	int lBrowseH	= 20;


	// Execute Button
	AddRegion( "ButtonExecute_GapKeys", "ButtonExecute_GapKeys",
	/* x */			lSpace,		kFBAttachLeft,		"",					1.0,
	/* y */			lSpace,		kFBAttachTop,	"",		1.0,
	/* w */			lButtonW,	kFBAttachNone,		NULL,				1.0,
	/* h */			lButtonH,	kFBAttachNone,		NULL,				1.0 );

	

	
	SetControl( "ButtonExecute_GapKeys", mExecute_GapKeys_Button );
}

void ORTool_Template::UIConfigure()
///////////////////////////////////////////////////////////////////////////////
//	Configures the UI
///////////////////////////////////////////////////////////////////////////////
{
	// Configure Execute buttons
	mExecute_GapKeys_Button.OnClick.Add( this, (FBCallback) &ORTool_Template::EventExecute_GapKeys_ButtonClick );
	mExecute_GapKeys_Button.Caption = "Execute GapKeys";

}

void ORTool_Template::UIReset()
///////////////////////////////////////////////////////////////////////////////
//	Resets the UI
///////////////////////////////////////////////////////////////////////////////
{
}

void ORTool_Template::UIRefresh()
///////////////////////////////////////////////////////////////////////////////
//	Refreshes the UI
///////////////////////////////////////////////////////////////////////////////
{
}


/*****************************************************************************/
/*                                                                           */
/*                                CALLBACKS                                  */
/*                                                                           */
/*****************************************************************************/


void ORTool_Template::EventExecute_GapKeys_ButtonClick( HISender pSender, HKEvent pEvent )
///////////////////////////////////////////////////////////////////////////////
//	Callback for Button "Execute GapKeys"
///////////////////////////////////////////////////////////////////////////////
{ __FUNCOUT
	FBTrace("Button GapKeys was pressed!");	
	ExportModel( FBSystem().SceneRootModel );	
	
}

/************************************************
*	Export the information for a given model.
************************************************/
void ORTool_Template::ExportModel( HFBModel pModel)
{
	FBTrace ("in the function exportModel\n");

	FBTime lTime = FBTime(0,0,0,11);

	FBTrace(pModel->Name); //grabs the Scene Component

	for(int i=0;i< pModel->Children.GetCount();i++) //getting the children of the Scene
	{
		FBTrace(pModel->Children[i]->Name); //grabs the optical component
		if (pModel->Children[i]->Is(FBModelOptical::TypeInfo)) //the optical component is of type FBModelOptical
		{
			FBTrace("1.-->Model is an FBModelOptical \n");
			//cast the FBModel as an FBModelOptical, the reason I need this is later I need to SetModelOptical, so I need the parent of lHMarkerOptical which is this lHOptical. 
			HFBModelOptical lHOptical = (HFBModelOptical)pModel->Children[i];	
			//gets the selected marker, in this case it's M_RightShin
			FBModelList lModelList;
			FBGetSelectedModels( lModelList );
			int count = lModelList.GetCount();
			for( int j = 0; j < count; j++ )
			{ 
				HFBModel lModel = lModelList[j];
				char* name = lModel->Name;
				FBTrace( "Model is : %s\n", name );
				if( lModel->Is(FBModelMarkerOptical::TypeInfo) )//the M_RightShin component is of type FBModelMarkerOptical
				{
					HFBModelMarkerOptical lHMarkerOptical = (HFBModelMarkerOptical)lModel;	//cast the model to type FBModelMarkerOptical

					//Getting the Segments, because you have to get the segments to get the gaps count to renew, (BUG)
					lHMarkerOptical->SetModelOptical(lHOptical); 

					FBTrace("Marker Segment Count is %d\n", lHMarkerOptical->Segments.GetCount());
					FBTrace("Marker Gap Count is %d\n", lHMarkerOptical->Gaps.GetCount()); //now the gap count doesn't return 0 but the actual value...

					FBPlayerControl().Goto(FBTime(0, 0, 0, 11));
					//inserts gap key at a default location....
					lHMarkerOptical->Gaps[1].InsertControlKey(lTime);
					
					//Trying to se the gap key where I want it now.....
					HFBAnimationNode lAnimNode = lHMarkerOptical->Gaps[1].Data;
					
					HFBAnimationNode lTransNode = lAnimNode->Nodes.Find("X");
					if (lTransNode)
					{
						FBTrace("Found Node X\n");
						double value = -200.0;
						lTransNode->KeyAdd(&value);
					}
				}
			}
		}
	}
}

void ORTool_Template::EventToolShow( HISender pSender, HKEvent pEvent )
///////////////////////////////////////////////////////////////////////////////
//	Callback for Tool Show
///////////////////////////////////////////////////////////////////////////////
{
	FBEventShow lEvent( pEvent );

	if( lEvent.Shown )
	{
		// Reset the UI here.
	}
	else
	{

	}
}

void ORTool_Template::EventToolIdle( HISender pSender, HKEvent pEvent )
///////////////////////////////////////////////////////////////////////////////
//	Callback for Tool Idle
///////////////////////////////////////////////////////////////////////////////
{
	UIRefresh();
}