#ifndef __ORTOOL_TEMPLATE_TOOL_H__
#define __ORTOOL_TEMPLATE_TOOL_H__

//--- SDK include
#include <fbsdk/fbsdk.h>
#include <fbsdk/fbundomanager.h> 

//--- Registration define
#define ORTOOLTEMPLATE__CLASSNAME	ORTool_Template
#define ORTOOLTEMPLATE__CLASSSTR	"ORTool_Template"

#define __FUNCOUT FBTrace( "// ---- [  %s  ]\n", __FUNCTION__ );

/*****************************************************************************/
/*  INTERFACE                                                                */
/*****************************************************************************/

class ORTool_Template : public FBTool
///////////////////////////////////////////////////////////////////////////////
//	
//	Class : ORTool_Template
//
///////////////////////////////////////////////////////////////////////////////
{
	// ---- FiLMBOX Tool declaration.
	//
	FBToolDeclare( ORTool_Template, FBTool );

public:
	// ---- FiLMBOX Construction/Destruction,
	//
	virtual bool FBCreate();
	virtual void FBDestroy();

private:
	// ---- Configure the scene
	//
	void	ConfigureScene();

	// ---- Create the UI
	//
	void	UICreate	();
	void	UIConfigure	();
	void	UIReset		();
	void	UIRefresh	();

	// ---- UI Callbacks
	//
	void	EventExecute_GapKeys_ButtonClick( HISender pSender, HKEvent pEvent );	
	
	
	void ExportModel( HFBModel pModel);
	void EventSceneChange( HISender pSender, HKEvent pEvent );
	void OnConnectionDataNotify( HISender pSender, HKEvent pEvent     );
	
	// ---- Tool Callbacks
	//
	void	EventToolShow	( HISender pSender, HKEvent pEvent );
	void	EventToolIdle	( HISender pSender, HKEvent pEvent	);		//!< \b Idle event in tool.

private:
	// ---- Helper Interfaces
	//
	FBSystem	mSystem;
	FBFbxManager mFbxManager;
	FBApplication mApplication;
		
	// ---- Controls
	//
	FBEdit	mEditControl;

	FBButton	mExecute_GapKeys_Button;

	
};

#endif